// Code generated by go-swagger; DO NOT EDIT.

package build_artifact

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	models "gitlab.com/pear-slices/mobile_platform/bitrise-step-api-build-trigger/models"
)

// ArtifactShowReader is a Reader for the ArtifactShow structure.
type ArtifactShowReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ArtifactShowReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewArtifactShowOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewArtifactShowBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 401:
		result := NewArtifactShowUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewArtifactShowNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewArtifactShowInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewArtifactShowOK creates a ArtifactShowOK with default headers values
func NewArtifactShowOK() *ArtifactShowOK {
	return &ArtifactShowOK{}
}

/*ArtifactShowOK handles this case with default header values.

OK
*/
type ArtifactShowOK struct {
	Payload *models.V0ArtifactShowResponseModel
}

func (o *ArtifactShowOK) Error() string {
	return fmt.Sprintf("[GET /apps/{app-slug}/builds/{build-slug}/artifacts/{artifact-slug}][%d] artifactShowOK  %+v", 200, o.Payload)
}

func (o *ArtifactShowOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.V0ArtifactShowResponseModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewArtifactShowBadRequest creates a ArtifactShowBadRequest with default headers values
func NewArtifactShowBadRequest() *ArtifactShowBadRequest {
	return &ArtifactShowBadRequest{}
}

/*ArtifactShowBadRequest handles this case with default header values.

Bad Request
*/
type ArtifactShowBadRequest struct {
	Payload *models.ServiceStandardErrorRespModel
}

func (o *ArtifactShowBadRequest) Error() string {
	return fmt.Sprintf("[GET /apps/{app-slug}/builds/{build-slug}/artifacts/{artifact-slug}][%d] artifactShowBadRequest  %+v", 400, o.Payload)
}

func (o *ArtifactShowBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ServiceStandardErrorRespModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewArtifactShowUnauthorized creates a ArtifactShowUnauthorized with default headers values
func NewArtifactShowUnauthorized() *ArtifactShowUnauthorized {
	return &ArtifactShowUnauthorized{}
}

/*ArtifactShowUnauthorized handles this case with default header values.

Unauthorized
*/
type ArtifactShowUnauthorized struct {
	Payload *models.ServiceStandardErrorRespModel
}

func (o *ArtifactShowUnauthorized) Error() string {
	return fmt.Sprintf("[GET /apps/{app-slug}/builds/{build-slug}/artifacts/{artifact-slug}][%d] artifactShowUnauthorized  %+v", 401, o.Payload)
}

func (o *ArtifactShowUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ServiceStandardErrorRespModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewArtifactShowNotFound creates a ArtifactShowNotFound with default headers values
func NewArtifactShowNotFound() *ArtifactShowNotFound {
	return &ArtifactShowNotFound{}
}

/*ArtifactShowNotFound handles this case with default header values.

Not Found
*/
type ArtifactShowNotFound struct {
	Payload *models.ServiceStandardErrorRespModel
}

func (o *ArtifactShowNotFound) Error() string {
	return fmt.Sprintf("[GET /apps/{app-slug}/builds/{build-slug}/artifacts/{artifact-slug}][%d] artifactShowNotFound  %+v", 404, o.Payload)
}

func (o *ArtifactShowNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ServiceStandardErrorRespModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewArtifactShowInternalServerError creates a ArtifactShowInternalServerError with default headers values
func NewArtifactShowInternalServerError() *ArtifactShowInternalServerError {
	return &ArtifactShowInternalServerError{}
}

/*ArtifactShowInternalServerError handles this case with default header values.

Internal Server Error
*/
type ArtifactShowInternalServerError struct {
	Payload *models.ServiceStandardErrorRespModel
}

func (o *ArtifactShowInternalServerError) Error() string {
	return fmt.Sprintf("[GET /apps/{app-slug}/builds/{build-slug}/artifacts/{artifact-slug}][%d] artifactShowInternalServerError  %+v", 500, o.Payload)
}

func (o *ArtifactShowInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ServiceStandardErrorRespModel)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
